#include <avr/io.h>
#include <stdbool.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>

#include "./timer1_timebase.h"


uint8_t volatile prescaler;

void InitTimer1_Timebase(void){
	//Timer einstellen
    prescaler = (uint8_t)DEBOUNCE;
	TCCR1B = 1<<WGM12^1<<CS10;		// divide by 1
									// clear on compare
  	OCR1A = XTAL / DEBOUNCE - 1;
  	TCNT1 = 0;
  	TIMSK1 = 1<<OCIE1A;
}

ISR (TIMER1_COMPA_vect){
/************************************************************************/
/*			Insert Key Debouncing Here			*/
/************************************************************************/

    TimebaseTick();
#if XTAL % DEBOUNCE
  OCR1A = XTAL / DEBOUNCE - 1;		// compare DEBOUNCE - 1 times
#endif
  if( --prescaler == 0 ){
    prescaler = (uint8_t)DEBOUNCE;
    OneSecondTick();
#if XTAL % DEBOUNCE			// handle remainder
    OCR1A = XTAL / DEBOUNCE + XTAL % DEBOUNCE - 1; // compare once per second
#endif
  }
}
